//rs232.cpp
//18.09.2006
//micbor@mail.ru

#include "rs232.h"

Port::Port()
{
printf("инициализация порта по умолчанию\n");
comport.speed=19200;
comport.bits=8;
comport.RTSus=false;//Также называется CRTSCTS 
comport.parity=0;

fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY | O_NDELAY);
if (fd<0) 
{printf("ошибка открытия порта \n");
 perror("error open com port");}
else
printf("/dev/ttyS0 speed=19200 bits=8 CRTSCTS=false parity=false \n");
    
tcgetattr(fd,&oldtio);//запомнить настройки порта    
fcntl(fd, F_SETFL, 0);
bzero(&newtio, sizeof(newtio)); //очистить настройки порта
newtio.c_cflag=BAUDRATE | CS8 | CLOCAL | CREAD;
newtio.c_cflag &= ~CSIZE;    
newtio.c_cflag |= CS8;
newtio.c_cflag &= ~PARENB;//отсутствует проверка на четность
newtio.c_cflag &= ~CSTOPB;
newtio.c_cflag &= ~CRTSCTS;
newtio.c_cc[VTIME]   = 0;   //посимвольный таймер не используется 
newtio.c_cc[VMIN]     = 1;   //кол символов принимаемых за 1 раз 
cfsetispeed(&newtio, B19200);
cfsetospeed(&newtio, B19200);
tcsetattr(fd,TCSANOW,&newtio);
}

Port::Port(char *namePort, long int speed, int bits, bool crtscts, char parity)
{
printf("инициализация порта\n");
strcpy(comport.nameport,namePort);    
fd = open(namePort, O_RDWR | O_NOCTTY | O_NDELAY);
if (fd<0) 
{printf("ошибка открытия порта \n");
    perror("error open com port");
}
else
{printf("%s  speed=/d%n bits=%d\n",namePort,speed,bits);}
comport.speed=speed;
comport.bits=bits;
comport.RTSus=CRTSCTS;//Также называется CRTSCTS 
comport.parity=parity;

tcgetattr(fd,&oldtio);//запомнить настройки порта    
fcntl(fd, F_SETFL, 0);
bzero(&newtio, sizeof(newtio)); //очистить настройки порта
newtio.c_cflag=BAUDRATE | CS8 | CLOCAL | CREAD;

 newtio.c_cflag &= ~CSIZE;    
    
 switch (comport.bits)//битность
 {   case 5:{newtio.c_cflag |= CS5;};break;    
     case 6:{newtio.c_cflag |= CS6;};break;   
     case 7:{newtio.c_cflag |= CS7;};break;   
     case 8:{newtio.c_cflag |= CS8;};break;   
default :{newtio.c_cflag |= CS8;};
  }
 
switch (comport.parity)//четность
 {   case 0:{newtio.c_cflag &= ~PARENB;//отсутствует проверка на четность
                 newtio.c_cflag &= ~CSTOPB;
                };break;    
     case 1:{newtio.c_cflag |= PARENB;//проверка на четность 
                 newtio.c_cflag &= ~PARODD;
                 newtio.c_cflag &= ~CSTOPB;
	  };break;   
     case 2:{newtio.c_cflag |= PARENB;//проверка на нечетность
                 newtio.c_cflag |= PARODD;
                 newtio.c_cflag &= ~CSTOPB;
	  };break;   
     case 3:{newtio.c_cflag &= ~PARENB;//пробел
                newtio.c_cflag &= ~CSTOPB;
	  };break;   
default :{newtio.c_cflag &= ~PARENB;//по умолчанию отсутсвует
             newtio.c_cflag &= ~CSTOPB;};
  }    

if (comport.RTSus==true) 
            {newtio.c_cflag |= CRTSCTS;    }// Также называется CRTSCTS 
 else
           {newtio.c_cflag &= ~CRTSCTS;}

newtio.c_cc[VTIME]   = 0;   //посимвольный таймер не используется 
newtio.c_cc[VMIN]     = 1;   //кол символов принимаемых за 1 раз 

    switch (comport.speed)//задание скорости порта
    {case 110:{cfsetispeed(&newtio, B110);
                    cfsetospeed(&newtio, B110);};break;
     case 300:{cfsetispeed(&newtio, B300);
	      cfsetospeed(&newtio, B300);};break;
     case 600:{cfsetispeed(&newtio, B600);
	      cfsetospeed(&newtio, B600);};break;
     case 1200:{cfsetispeed(&newtio, B1200);
	        cfsetospeed(&newtio, B1200);};break;
     case 2400:{cfsetispeed(&newtio, B2400);
	        cfsetospeed(&newtio, B2400);};break;
     case 4800:{cfsetispeed(&newtio, B4800);
	        cfsetospeed(&newtio, B4800);};break;
     case 9600:{cfsetispeed(&newtio, B9600);
	        cfsetospeed(&newtio, B9600);};break;
     case 19200:{cfsetispeed(&newtio, B19200);
	         cfsetospeed(&newtio, B19200);};break;
     case 38400:{cfsetispeed(&newtio, B38400);
	         cfsetospeed(&newtio, B38400);};break;
     case 57600:{cfsetispeed(&newtio, B57600);
	         cfsetospeed(&newtio, B57600);};break;
     case 115200:{cfsetispeed(&newtio, B115200);
	           cfsetospeed(&newtio, B115200);};break;
     case 230400:{cfsetispeed(&newtio, B230400);
	           cfsetospeed(&newtio, B230400);};break;
     default :{cfsetispeed(&newtio, B19200);
	   cfsetospeed(&newtio, B19200);};
    }
//newtio.c_cflag |= (CLOCAL | CREAD);    

tcsetattr(fd,TCSANOW,&newtio);
}

Port::Port(char *name_f)//==========================================
{
char tcrtscts[10];
  for (int i =0; i!=80; i++)
  comport.nameport[i]=0;
  printf(" init %s\n",name_f);
  fl = fopen(name_f, "rt");
  if (fscanf(fl,"port\t%s\n",comport.nameport)==0)
  strcpy(comport.nameport,"/dev/ttyS0");
  printf("port\t%s\n",comport.nameport);
  if (fscanf(fl,"speed\t%d\n",&comport.speed)==0)
      comport.speed=19200;
  printf("speed\t%d\n",comport.speed);
  if (fscanf(fl,"bits\t%d\n",&comport.bits)==0)
      comport.bits=8;
  printf("bits\t%d\n",comport.bits);
  if (fscanf(fl,"CRTSCTS\t%s\n",tcrtscts)==0)
  if ((tcrtscts[0]=='T') || (tcrtscts[0]=='t'))
     comport.RTSus=true;
     else
     comport.RTSus=false;
  if (fscanf(fl,"parity\t%d\n",&comport.parity)==0)
      comport.parity=0;
  printf("parity\t%d\n",comport.parity);
  if (fscanf(fl,"stopbit\t%d\n",&comport.stopbit)==0)
      comport.stopbit=1;
  printf("stopbit\t%d\n",comport.stopbit);
  fclose(fl);    
  
 printf("%s\n",comport.nameport); 
  
fd = open(comport.nameport, O_RDWR | O_NOCTTY | O_NDELAY);
 //printf("о\n"); 
if (fd<0) 
{printf("ошибка открытия порта \n");
    //perror("error open com port");
}



tcgetattr(fd,&oldtio);//запомнить настройки порта    
fcntl(fd, F_SETFL, 0);
bzero(&newtio, sizeof(newtio)); //очистить настройки порта
newtio.c_cflag=BAUDRATE | CS7 | CLOCAL | CREAD;

 newtio.c_cflag &= ~CSIZE;    
    
 switch (comport.bits)//битность
 {   case 5:{newtio.c_cflag |= CS5;};break;    
     case 6:{newtio.c_cflag |= CS6;};break;   
     case 7:{newtio.c_cflag |= CS7;};break;   
     case 8:{newtio.c_cflag |= CS8;};break;   
default :{newtio.c_cflag |= CS8;};
  }

switch (comport.parity)//четность
 {   case 0:{newtio.c_cflag &= ~PARENB;//отсутствует проверка на четность
                 newtio.c_cflag &= ~CSTOPB;
                };break;    
     case 1:{newtio.c_cflag |= PARENB;//проверка на четность 
                 newtio.c_cflag &= ~PARODD;
                 newtio.c_cflag &= ~CSTOPB;
	  };break;   
     case 2:{newtio.c_cflag |= PARENB;//проверка на нечетность
                 newtio.c_cflag |= PARODD;
                 newtio.c_cflag &= ~CSTOPB;
	  };break;   
     case 3:{newtio.c_cflag &= ~PARENB;//пробел
                newtio.c_cflag &= ~CSTOPB;
	  };break;   
default :{newtio.c_cflag &= ~PARENB;//по умолчанию отсутсвует
             newtio.c_cflag &= ~CSTOPB;};
  }    

switch (comport.stopbit)//стоп бит
 {
     case 1:{newtio.c_cflag &= ~CSTOPB;};break;
     case 2:{newtio.c_cflag |= CSTOPB; };break;
default :{newtio.c_cflag &= ~CSTOPB;};//по умолчанию отсутсвует
  }

if (comport.RTSus==true) 
            {newtio.c_cflag |= CRTSCTS;    }// Также называется CRTSCTS 
 else
           {newtio.c_cflag &= ~CRTSCTS;}

newtio.c_cc[VTIME]   = 0;   //посимвольный таймер не используется 
newtio.c_cc[VMIN]     = 1;   //кол символов принимаемых за 1 раз 

    switch (comport.speed)//задание скорости порта
    {case 110:{cfsetispeed(&newtio, B110);
                    cfsetospeed(&newtio, B110);};break;
     case 300:{cfsetispeed(&newtio, B300);
	      cfsetospeed(&newtio, B300);};break;
     case 600:{cfsetispeed(&newtio, B600);
	      cfsetospeed(&newtio, B600);};break;
     case 1200:{cfsetispeed(&newtio, B1200);
	        cfsetospeed(&newtio, B1200);};break;
     case 2400:{cfsetispeed(&newtio, B2400);
	        cfsetospeed(&newtio, B2400);};break;
     case 4800:{cfsetispeed(&newtio, B4800);
	        cfsetospeed(&newtio, B4800);};break;
     case 9600:{cfsetispeed(&newtio, B9600);

	        cfsetospeed(&newtio, B9600);};break;
     case 19200:{cfsetispeed(&newtio, B19200);

	         cfsetospeed(&newtio, B19200);};break;
     case 38400:{cfsetispeed(&newtio, B38400);
	         cfsetospeed(&newtio, B38400);};break;
     case 57600:{cfsetispeed(&newtio, B57600);
	         cfsetospeed(&newtio, B57600);};break;
     case 115200:{cfsetispeed(&newtio, B115200);
	           cfsetospeed(&newtio, B115200);};break;
     case 230400:{cfsetispeed(&newtio, B230400);
	           cfsetospeed(&newtio, B230400);};break;
     default :{cfsetispeed(&newtio, B19200);
	   cfsetospeed(&newtio, B19200);};
    }
//newtio.c_cflag |= (CLOCAL | CREAD);    

tcsetattr(fd,TCSANOW,&newtio);  
}

void Port::get_paramPort(char *name_f)//===================================================
{
  printf("get_paramPort\n");
  fl = fopen(name_f, "rt");
  if (fscanf(fl,"port\t%s\n",comport.nameport)==0)
  strcpy(comport.nameport,"/dev/ttyS0");
  printf("port\t%s\n",comport.nameport);
  if (fscanf(fl,"speed\t%ld",&comport.speed)==0)
      comport.speed=19200;
  printf("speed\t%ld\n",comport.speed);
  fclose(fl);    
}


void Port::edit_paramPort(char *name_f, char *namePort, long int speed)
{
  printf("edit_paramPort\n");
  strcpy(comport.nameport,namePort);
  comport.speed=speed;
  init();
  fl = fopen(name_f, "rt");
  fprintf(fl,"port\t%s\n",namePort);
  fprintf(fl,"speed\t%ln\n",speed); 
  fclose(fl);
}

bool Port::init()
{
printf("initttt\n");
fd = open(comport.nameport, O_RDWR | O_NOCTTY | O_NDELAY);
if (fd<0) 
{printf("ошибка открытия порта \n");
    return(false);
    perror("error open com port");
}
else
{return(true);}
    

tcgetattr(fd,&oldtio);//запомнить настройки порта    
fcntl(fd, F_SETFL, 0);
bzero(&newtio, sizeof(newtio)); //очистить настройки порта
newtio.c_cflag=BAUDRATE | CS7 | CLOCAL | CREAD;

 newtio.c_cflag &= ~CSIZE;    
    
 switch (comport.bits)//битность
 {   case 5:{newtio.c_cflag |= CS5;};break;    
     case 6:{newtio.c_cflag |= CS6;};break;   
     case 7:{newtio.c_cflag |= CS7;};break;   
     case 8:{newtio.c_cflag |= CS8;};break;   
default :{newtio.c_cflag |= CS8;};
  }
 
switch (comport.parity)//четность
 {   case 0:{newtio.c_cflag &= ~PARENB;//отсутствует проверка на четность
                 newtio.c_cflag &= ~CSTOPB;
                };break;    
     case 1:{newtio.c_cflag |= PARENB;//проверка на четность 
                 newtio.c_cflag &= ~PARODD;
                 newtio.c_cflag &= ~CSTOPB;
	  };break;   
     case 2:{newtio.c_cflag |= PARENB;//проверка на нечетность
                 newtio.c_cflag |= PARODD;
                 newtio.c_cflag &= ~CSTOPB;
	  };break;   
     case 3:{newtio.c_cflag &= ~PARENB;//пробел
                newtio.c_cflag &= ~CSTOPB;
	  };break;   
default :{newtio.c_cflag &= ~PARENB;//по умолчанию отсутсвует
             newtio.c_cflag &= ~CSTOPB;};
  }    

if (comport.RTSus==true) 
            {newtio.c_cflag |= CRTSCTS;    }// Также называется CRTSCTS 
 else
           {newtio.c_cflag &= ~CRTSCTS;}

newtio.c_cc[VTIME]   = 0;   //посимвольный таймер не используется 
newtio.c_cc[VMIN]     = 1;   //кол символов принимаемых за 1 раз 

    switch (comport.speed)//задание скорости порта
    {case 110:{cfsetispeed(&newtio, B110);
                    cfsetospeed(&newtio, B110);};break;
     case 300:{cfsetispeed(&newtio, B300);
	      cfsetospeed(&newtio, B300);};break;
     case 600:{cfsetispeed(&newtio, B600);
	      cfsetospeed(&newtio, B600);};break;
     case 1200:{cfsetispeed(&newtio, B1200);
	        cfsetospeed(&newtio, B1200);};break;
     case 2400:{cfsetispeed(&newtio, B2400);
	        cfsetospeed(&newtio, B2400);};break;
     case 4800:{cfsetispeed(&newtio, B4800);
	        cfsetospeed(&newtio, B4800);};break;
     case 9600:{cfsetispeed(&newtio, B9600);
	        cfsetospeed(&newtio, B9600);};break;
     case 19200:{cfsetispeed(&newtio, B19200);
	         cfsetospeed(&newtio, B19200);};break;
     case 38400:{cfsetispeed(&newtio, B38400);
	         cfsetospeed(&newtio, B38400);};break;
     case 57600:{cfsetispeed(&newtio, B57600);
	         cfsetospeed(&newtio, B57600);};break;
     case 115200:{cfsetispeed(&newtio, B115200);
	           cfsetospeed(&newtio, B115200);};break;
     case 230400:{cfsetispeed(&newtio, B230400);
	           cfsetospeed(&newtio, B230400);};break;
     default :{cfsetispeed(&newtio, B19200);
	   cfsetospeed(&newtio, B19200);};
    }
//newtio.c_cflag |= (CLOCAL | CREAD);    

tcsetattr(fd,TCSANOW,&newtio);
}

//=========================================================================

Port_io::Port_io()
{
   p_i_f=0;
   p_i_e=0;
   m_array_i = new unsigned char[255];
   size_i=255;
   p_o_f=0;
   p_o_e=0;
   m_array_o = new unsigned char[255]; 
   size_o=255; 
}

Port_io::Port_io(char *namePort,int _size_i, int _size_o): Port(namePort), ssize_i(_size_i),  ssize_o(_size_o)
{
   p_i_f=0;
   p_i_e=0;
   size_i=_size_i;
   m_array_i = new unsigned char[size_i];
   p_o_f=0;
   p_o_e=0;
   size_o=_size_o; 
   m_array_o = new unsigned char[size_o]; 
}

Port_io::Port_io(char *namePort): Port(namePort)
{
   p_i_f=0;
   p_i_e=0;
   m_array_i = new unsigned char[255];
   size_i=255;
   p_o_f=0;
   p_o_e=0;
   m_array_o = new unsigned char[255]; 
   size_o=255;  
}

Port_io::~Port_io()
{   delete m_array_o;
    size_o=0;
    delete m_array_i;
    size_i=0;}

void Port_io::init(int fdd)
{
   fd=fdd;   
   p_i_f=0;
   p_i_e=0;
   p_o_f=0;
   p_o_e=0;
}

unsigned char * Port_io::readCom()
{
   unsigned char bt;
    read(fd,&bt,1);
    m_array_i[p_i_e]=bt;
    if (p_i_e==size_i)
        p_i_e=0;
    else
        p_i_e++;
    if (p_i_e==p_i_f)
       {printf("переполнение m_array_i\n");
        if (p_i_f==size_i)
           p_i_f=0; 
        else
           p_i_f++;
       }
    return m_array_i;
}


unsigned char Port_io::readComk()
{
   unsigned char bt;
    read(fd,&bt,1);
    return bt;
}

bool Port_io::writeCom(unsigned char *ch, int size)
{
//  pio;
  //for (int i=0; i!=size; i++)
  //m_array_i[i]=ch[i]; 

  write(fd,ch,size);
  return true;
}
